//+------------------------------------------------------------------+
//|                                                        frama.mq4 |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1  DeepSkyBlue
#property indicator_width1  2

//
//
//
//
//

extern int FramaPeriod = 14;
extern int FramaPrice  = PRICE_CLOSE;
double frmBuffer[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,frmBuffer);
   IndicatorShortName("Frama ( "+FramaPeriod+")");         
   return(0);
}

int deinit()
{
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//


int start()
{
   int counted_bars=IndicatorCounted();
   int limit,i;

   if(counted_bars < 0)   return(-1);
   if(counted_bars > 0)   counted_bars--;
           limit = MathMin(Bars-counted_bars,Bars-1);
           
   //
   //
   //
   //
   //

      double halfPeriod = FramaPeriod/2;
      for(i = limit; i >= 0; i--)
      {
         double price = iMA(NULL,0,1,0,MODE_SMA,FramaPrice,i);
         if (i>(Bars-halfPeriod))
         {
            frmBuffer[i] = price;
            continue;
         }
         
         //
         //
         //
         //
         //
         
         double hh = High[iHighest(NULL,0,MODE_HIGH,FramaPeriod,i)];
         double ll = Low [iLowest (NULL,0,MODE_LOW ,FramaPeriod,i)];
         double n3 = (hh-ll)/FramaPeriod;
                hh = High[iHighest(NULL,0,MODE_HIGH,halfPeriod,i)];
                ll = Low [iLowest (NULL,0,MODE_LOW ,halfPeriod,i)];
         double n1 = (hh-ll)/halfPeriod;
                hh = High[iHighest(NULL,0,MODE_HIGH,halfPeriod,i+halfPeriod)];
                ll = Low [iLowest (NULL,0,MODE_LOW ,halfPeriod,i+halfPeriod)];
         double n2 = (hh-ll)/halfPeriod;
         
         //
         //
         //
         //
         //
         
         double dimen = 0;
               if (n1>0 && n2>0 && n3>0) dimen = (MathLog(n1+n2)-MathLog(n3))/MathLog(2.0);
         double alpha = MathMin(MathMax(MathExp(-4.6*(dimen-1.0)),0.01),1.0);
         frmBuffer[i] = alpha*price+(1-alpha)*frmBuffer[i+1];
      }

   //
   //
   //
   //
   //

   return(0);      
}